function SortData(TbodyId, Index, CmpFunc, GetFunc, SortTypeId, SortType) {
	var i;
	var Value = new Array;
	var TbodyObject = document.getElementById(TbodyId);
	var Rows = TbodyObject.rows;
	var Number = Rows.length;
	var TbodyNew = document.createElement("tbody");
	if (SortTypeId) document.getElementById(SortTypeId).innerHTML = SortType;
	CmpFunc = CmpFunc || arguments.callee.compareFunc;
	GetFunc = GetFunc || arguments.callee.getFunc || function(Cell){return Cell.nodeName;};
	for (i = 0; i < Number; i++) {
		Value[i] = Object(GetFunc(Rows[i].cells[Index], Rows[i].cells[0]));
		Value[i].row = Rows[i];
	}
	if (CmpFunc) {
		Value.sort(CmpFunc);
	}
	else {
		Value.sort();
	}
	TbodyObject.parentNode.replaceChild(TbodyNew, TbodyObject);
	for (i = 0; i < Number; i++) TbodyObject.appendChild(Value[i].row);
	TbodyNew.parentNode.replaceChild(TbodyObject, TbodyNew);
}
function GetDataFunc1(Cell) {
	return eval(Cell.firstChild.nodeValue);
}
function GetDataFunc2(Cell1, Cell2) {
	return ((Cell1.firstChild.nodeValue == "--") ? 0 : eval(Cell1.firstChild.nodeValue) * 10000) + 10000 - eval(Cell2.firstChild.nodeValue);
}
function CompareFunc1(Value1, Value2) {
	return (Value1 > Value2) ? -1 : Value1 != Value2;
}
function CompareFunc2(Value1, Value2) {
	return (Value1 < Value2) ? -1 : Value1 != Value2;
}
function GetBytes(Text, Limit) {
	var c, i;
	var n = 0;
	var Length = Text.length;
	for (i = 0; i < Length; i++) {
		c = Text.charAt(i);
		if (c >= "" && c <= "") {
			n += 1;
		}
		else if (c == "&") {
			if (Text.charAt(i + 1) == "#" && Text.substring(i + 2, Text.length).match("^(([0-9]+)|([xX][0-9a-fA-F]+));")) {
				n += 1;
			}
			else {
				n += 5;
			}
		}
		else if (c == "<") {
			n += 4;
		}
		else if (c == ">") {
			n += 4;
		}
		else if (c == "\"") {
			n += 5;
		}
		else if (c == "'") {
			n += 5;
		}
		else if (c == "\r") {
			n += 5;
			if (Text.charAt(i + 1) == "\n") i++;
		}
		else if (c == "\n") {
			n += 5;
		}
		else if (escape(c).length > 3) {
			n += 2;
		}
		else {
			n += 1;
		}
		if (n >= Limit) {
			n = Limit;
			break;
		}
	}
	return n;
}
function Counter(Text1, Text2, Type) {
	if (Type == 0) {
		Text2.value = GetBytes(Text1.value, 999);
	}
	else if (Type == 1) {
		Text2.value = parseInt((GetBytes(Text1.value, 1998) + 1) / 2);
	}
	else {
		Text2.value = parseInt((GetBytes(Text1.value, 3998) + 1) / 2);
	}
}
function ChangeRow(TableId, Rows) {
	var i;
	var Tbody = document.getElementById(TableId).tBodies[0];
	for (i = Rows; i < Tbody.rows.length; i++) {
		Tbody.rows[i].onmouseover = function(){this.style.backgroundColor="#fcfcf0"};
		Tbody.rows[i].onmouseout = function(){this.style.backgroundColor="#fcfcfc"};
	}
}
function ChangeRow2(TableId) {
	this.table = TableId;
	this.PosRow = this._SetRow();
}
ChangeRow2.prototype.Set = function() {
	var Pos = new Array;
	var Cell;
	var x, y, i;
	for (i = 1; i < arguments.length; i++) Pos[i - 1] = arguments[i];
	for (y in this.table.rows) {
		if (y < arguments[0]) continue;
		for (var x in this.table.rows[y].cells) {
			Cell = this.table.rows[y].cells[x];
			if (!Cell.style) continue;
			AddEvent(Cell, 'mouseover', this.coloring(y, x, this.color || '#fcfcf0', Pos));
			AddEvent(Cell, 'mouseout', this.coloring(y, x, '', Pos));
		}
	}
}
ChangeRow2.prototype.coloring = function(y, x, Color, Pos)
{
	var _this = this;
	var CellSpan = new Array;
	var Cell = new Array;
	var Length;
	var i;
	Length = this.table.rows[y].cells.length;
	for (i = 0; i < Length; i++) Cell[i] = this.table.rows[y].cells[i];
	return function (e) {
		for (i = 0; i < Pos.length; i++) {
			CellSpan[Pos[i]] = _this.GetParentRow(y, x, Pos[i]);
			CellSpan[Pos[i]].style.backgroundColor = Color || '';
		}
		for (i = 0; i < Length; i++) Cell[i].style.backgroundColor = Color || '';
	}
}
ChangeRow2.prototype.GetParentRow = function(y, x, p) {
	var Pos = this._Get(this.PosRow, this.table.rows[y].cells[x].offsetTop);
	return this.table.rows[Pos].cells[p];
}
ChangeRow2.prototype._Get = function(Pos, m) {
	for (var i in Pos) if (Pos[i][1] < m + 5 && m < Pos[i][2]) return Pos[i][0];
	return 0;
}
ChangeRow2.prototype._SetRow = function() {
	var Pos = new Array;
	var Ret;
	var x = 0;
	for (var i in this.table.rows) {
		if (!this.table.rows[i].cells) continue;
		var cell = this.table.rows[i].cells[0];
		if (Ret-- && Ret >= 1) continue;
		Ret = (cell.rowSpan - 1);
		Pos[++x] = new Array;
		Pos[x][0] = i;
		Pos[x][1] = cell.offsetTop;
		Pos[x][2] = cell.offsetTop + cell.offsetHeight;
	}
	return Pos;
}
function ChangeRow3(TbodyId) {
	var i;
	var TbodyObject = document.getElementById(TbodyId);
	for (i = 0; i < TbodyObject.rows.length; i++) {
		TbodyObject.rows[i].onmouseover = function(){this.style.backgroundColor="#fcfcf0"};
		TbodyObject.rows[i].onmouseout = function(){this.style.backgroundColor="#fcfcfc"};
	}
}
function AddEvent(Obj, EventType, Func) {
	if (Obj.addEventListener) {
		Obj.addEventListener(EventType, Func, false);
	}
	else if (Obj.attachEvent) {
		Obj.attachEvent("on" + EventType, Func);
	}
	else {
		Obj["on" + EventType] = Func;
	}
}
